
#include "RobboLito.h"
#include "RobboTotalBase.h"
#include "Robbo_gen_mossa.h"

void InitRandom32 (uint64 x) {}

#include <stdarg.h>

void SEND (char* fmt, ...)
{
  va_list Value;
  va_start (Value, fmt);
  vfprintf (stdout, fmt, Value);
  va_end (Value);
  fflush (stdout);
}

static void
BITBOARD (typePOS *POSITION, int wK, int bK, type_PiSq * PiSq)
{
  uint8 *Squ = PiSq->sq;
  int i;
  POSITION->wKsq = wK;
  POSITION->bKsq = bK;
  wBitboardK = SqSet[wK];
  bBitboardK = SqSet[bK];
  wBitboardR = wBitboardQ = wBitboardN =
    wBitboardBL = wBitboardBD = wBitboardP = 0;
  bBitboardR = bBitboardQ = bBitboardN =
    bBitboardBL = bBitboardBD = bBitboardP = 0;
  PiSq->pedone = FALSE;
  for (i = 0; i < 4; i++)
    {
      if (PiSq->pi[i] == wEnumB && SqSet[Squ[i]] & DARK)
	{
	  wBitboardBD |= SqSet[Squ[i]];
	  continue;
	}
      if (PiSq->pi[i] == bEnumB && SqSet[Squ[i]] & DARK)
	{
	  bBitboardBD |= SqSet[Squ[i]];
	  continue;
	}
      if (PiSq->pi[i] == BlockedPawn)
	{
	  wBitboardP |= SqSet[Squ[i]];
	  bBitboardP |= SqSet[Squ[i] + 8];
	  PiSq->pedone = TRUE;
	  continue;
	}
      if (PiSq->pi[i] == bEnumP || PiSq->pi[i] == wEnumP)
	PiSq->pedone = TRUE;
      POSITION->bitboard[PiSq->pi[i]] |= SqSet[Squ[i]];
    }
}

#define UnderProm(x) \
  { Undo (POSITION, move); move = (move & 07777) + ( x << 12 ); \
    MakeWhite (POSITION, move); RobboTotalBaseScore (POSITION, &Value); \
    if (DISCO_PERDITA (Value)) \
      {  MARCO (TotalBase->mbuf, PositionNumber, d); \
	UndoWhite (POSITION, move); return; } \
    if (DISCO_PATTA (Value)) \
      { SetDraw (TotalBase, PositionNumber, d); RIMA++; } }

#define Bitboard2(x,y) ( ( (uint64) 1) << (x) ) | ( ( (uint64) 1) << (y) )

static const uint64 EPtable[8] =
  { Bitboard2 (B4, B4), Bitboard2 (A4, C4),
    Bitboard2 (B4, D4), Bitboard2 (C4, E4),
    Bitboard2 (D4, F4), Bitboard2 (E4, G4),
    Bitboard2 (F4, H4), Bitboard2 (G4, G4) };

static void
SetInit (RobboTotalBase * TotalBase, uint64 PositionNumber, uint64 d)
{
  TotalBase->sbuf[PositionNumber] = VALU_INCOG;
  if (d != -1)
    TotalBase->sbuf[d] = VALU_INCOG;
}

static void
SetDraw (RobboTotalBase * TotalBase, uint64 PositionNumber, uint64 d)
{
  TotalBase->sbuf[PositionNumber] = VALUE_DRAW;
  if (d != -1)
    TotalBase->sbuf[d] = VALUE_DRAW;
}

static void
ROTTO (RobboTotalBase * TotalBase, uint64 PositionNumber, uint64 d)
{
  TotalBase->sbuf[PositionNumber] = VALU_ROTTO;
  UnSet (TotalBase->mbuf, PositionNumber);
  Set (TotalBase->vbuf, PositionNumber);
  if (d == -1)
    return;
  TotalBase->sbuf[d] = VALU_ROTTO;
  UnSet (TotalBase->mbuf, d);
  Set (TotalBase->vbuf, d);
}

#define MARCO(ptr, A, B) { Set (ptr, A); if (B != -1) Set (ptr, B); }

static void
inizRIMA (RobboTotalBase *TotalBase, uint64 PositionNumber, uint64 d, int RIMA)
{
  if (RIMA > MASSIMO_RIMA)
    {
      printf ("MASSIMO RIMA\n");
      exit (1);
    }
  if (RIMA == 0)
    RIMA = PRIMERA_PERDITA;
  TotalBase->sbuf[PositionNumber] = RIMA;
  if (RIMA == PRIMERA_PERDITA)
    {
      Set (TotalBase->pbuf, PositionNumber);
      if (d != -1)
	Set (TotalBase->pbuf, d);
    }
  if (d != -1)
    TotalBase->sbuf[d] = RIMA;
}

void DrawBoard (typePOS* POSITION)
{
  char C[16] = "0PNKBBRQ";
  char ARR[256];
  int t, c, u;
  printf ("      +---+---+---+---+---+---+---+---+\n");
  for (t = R8; t >= R1; t--)
    {
      printf("   %i  |", t+1);
      for (c = FA; c <= FH; c++)
	{
	  u = POSITION->sq[c + 8 * t];
	  if (u >= 8)
	    printf ("<%c>", C[u - 8]);
	  else if (u > 0)
	    printf (" %c ", C[u]);
	  else if ((c + t) & 1)
	    printf ("   ");
	  else
	    printf (" . ");
	  printf ("|");
	}
      printf ("\n      +---+---+---+---+---+---+---+---+\n");
    }
  printf ("        a   b   c   d   e   f   g   h\n");
  printf ("%s\n", ARR);
}

static void
SetupPosition (typePOS *POSITION, RobboTotalBase *TotalBase, type_PiSq *PiSq)
{
  typeMoveList LIST[256], *list;
  int move, i, Value, RIMA, rf;
  uint64 PositionNumber, d, ep;
  boolean NON = TRUE;
  uint64 A;
  int b;
  uint32 m3;
  int vc;

  ott_indice (PiSq, &PositionNumber, &d, &rf);
  if (IS_ILLEGAL)
    {
      ROTTO (TotalBase, PositionNumber, d);
      return;
    }
  list = WhiteCaptures (POSITION, LIST, bBitboardOcc);

  RIMA = 0;
  SetInit (TotalBase, PositionNumber, d);
  for (i = 0; i < list - LIST; i++)
    {
      move = LIST[i].move;
      if (((move & 070000) >> 12) == 4)
	continue;
      MakeWhite (POSITION, move);
      Mobility (POSITION);
      if (IS_ILLEGAL)
	{
	  UndoWhite (POSITION, move);
	  continue;
	}
      if (!RobboTotalBaseScore (POSITION, &Value))
	{
	  printf ("MAL %d\n",Value);
	  DrawBoard (POSITION);
	  exit (1);
	}
      NON = FALSE;
      if (DISCO_PERDITA (Value))
	{
	  MARCO (TotalBase->mbuf, PositionNumber, d);
	  UndoWhite (POSITION, move);
	  return;
	}
      if (DISCO_PATTA (Value))
	{
	  SetDraw (TotalBase, PositionNumber, d);
	  RIMA++;
	}
      if (((move & 070000) >> 12) == 7)
	{
	  UnderProm (6);
	  UnderProm (5);
	  UnderProm (4);
	}
      UndoWhite (POSITION, move);
    }
  RIMA += CountWhite (POSITION, &ep);
  if (ep == -1)
    {
      ROTTO (TotalBase, PositionNumber, d);
      return;
    }
  while (ep)
    {
      b = BSF (ep);
      BitClear (b, ep);
      move = ((b - 16) << 6) | b;
      MakeWhite (POSITION, move);
      A = EPtable[FILE (POSITION->DYN->ep)] & bBitboardP;
      while (A)
	{
	  b = BSF (A);
	  BitClear (b, A);
	  m3 = FlagEP | (b << 6) | (POSITION->DYN->ep);
	  Make (POSITION, m3);
	  RobboTotalBaseScore (POSITION, &vc);
	  UndoWhite (POSITION, m3);
	  if (DISCO_PERDITA (vc))
	    {
	      RIMA--;
	      break;
	    }
	}
      UndoWhite (POSITION, move);
    }
  if (NON && !RIMA && !IN_CHECK)
    SetDraw (TotalBase, PositionNumber, d);
  else
    inizRIMA (TotalBase, PositionNumber, d, RIMA);
  return;
}


static void LOAD_re_fetta (RobboTotalBase *tb, int wK, int bK, int rf)
{
  int w, i, v, u;
  int a[4];
  boolean PEDONE = FALSE;
  for (u = 0; u < 4; u++)
    if (tb->p[u] == wEnumP)
      break;
  if (u == 4)
    return;
  for (i = 0; i < 4; i++)
    a[i] = tb->p[i];
  a[u] = wEnumQ;
  for (i = 0; i < 4; i++)
    if (a[i] == wEnumP || a[i] == bEnumP || a[i] == BlockedPawn)
      PEDONE = TRUE;
  if (PEDONE)
    {
      w = 2 * (FILE (wK) >= FE) + 1;
      LANCpez (w, wK);
      LANCpez (w, bK);
      rf = RE_pedone[64 * bK + wK];
    }
  else
    {
      w = oLANC[bK][wK];
      LANCnor (w, wK);
      LANCnor (w, bK);
      rf = RE_normale[64 * bK + wK];
    }
  v = TotalBaseTable[a[0]][a[1]][a[2]][a[3]];
  re_fetta (TABLE_TOTAL_BASES + (v % 65536), rf);
  a[u] = wEnumR;
  v = TotalBaseTable[a[0]][a[1]][a[2]][a[3]];
  re_fetta (TABLE_TOTAL_BASES + (v % 65536), rf);
  a[u] = wEnumB;
  v = TotalBaseTable[a[0]][a[1]][a[2]][a[3]];
  re_fetta (TABLE_TOTAL_BASES + (v % 65536), rf);
  a[u] = wEnumN;
  v = TotalBaseTable[a[0]][a[1]][a[2]][a[3]];
  re_fetta (TABLE_TOTAL_BASES + (v % 65536), rf);
}

static void
popolare (typePOS *POSITION, int *pi, RobboTotalBase * Tot1)
{
  int i, wK, bK, sq1, sq2, sq3, sq4, SQ1, SQ2, SQ3, SQ4,
    TER1, TER2, TER3, TER4, PawnFlag = FALSE;
  uint64 ci, d, pro;
  uint64 Clock = GetClock ();
  char NOME_FILE[1024];
  int rf, RF, re_fetta;

  for (wK = A1; wK <= H8; wK++)
    POSITION->sq[wK] = 0;
  SQ1 = SQ2 = SQ3 = SQ4 = A1;
  TER1 = TER2 = TER3 = TER4 = H8;
  if (pi[0] == 0)
    SQ1 = TER1 = -1;
  if (pi[1] == 0)
    SQ2 = TER2 = -1;
  POSITION->DYN->reversible = POSITION->DYN->oo = POSITION->DYN->ep = 0;
  if (pi[2] == 0)
    SQ3 = TER3 = -1;
  if (pi[3] == 0)
    SQ4 = TER4 = -1;
  if (pi[0] == wEnumP || pi[0] == bEnumP)
    {
      SQ1 = A2;
      TER1 = H7;
      PawnFlag = TRUE;
    }
  if (pi[1] == wEnumP || pi[1] == bEnumP)
    {
      SQ2 = A2;
      TER2 = H7;
      PawnFlag = TRUE;
    }
  if (pi[2] == wEnumP || pi[2] == bEnumP)
    {
      SQ3 = A2;
      TER3 = H7;
      PawnFlag = TRUE;
    }
  if (pi[3] == wEnumP || pi[3] == bEnumP)
    {
      SQ4 = A2;
      TER4 = H7;
      PawnFlag = TRUE;
    }
  if (pi[0] == BlockedPawn)
    {
      SQ1 = A2;
      TER1 = H6;
      PawnFlag = TRUE;
    }
  if (pi[1] == BlockedPawn)
    {
      SQ2 = A2;
      TER2 = H6;
      PawnFlag = TRUE;
    }
  if (pi[2] == BlockedPawn)
    {
      SQ3 = A2;
      TER3 = H6;
      PawnFlag = TRUE;
    }
  if (pi[3] == BlockedPawn)
    {
      SQ4 = A2;
      TER4 = H6;
      PawnFlag = TRUE;
    }
  if (!PawnFlag)
    pro = 462;
  else
    pro = 1806;
  RF = PawnFlag ? 1806 : 462;
  for (i = 0; i < 4; i++)
    pro *= Tot1->m[i];
  for (i = 0; i < 8; i++)
    Tot1->supp_indice[i] = 0xffffffff;
  Tot1->pro = pro;
  Tot1->PawnMult8 = (Tot1->PawnMult + 7) >> 3;
  Tot1->Fsupp = NULL;

  if (!Tot1->MEMORIA)
    {
      sprintf (NOME_FILE, "%sRIMA.%s", Tot1->DIR_NOME, Tot1->string);
      Tot1->Frima = fopen (NOME_FILE, "w+");
      sprintf (NOME_FILE, "%sMARC.%s", Tot1->DIR_NOME, Tot1->string);
      Tot1->Fmar = fopen (NOME_FILE, "w+");
      sprintf (NOME_FILE, "%sPERD.%s", Tot1->DIR_NOME, Tot1->string);
      Tot1->Fper = fopen (NOME_FILE, "w+");
      sprintf (NOME_FILE, "%sVITT.%s", Tot1->DIR_NOME, Tot1->string);
      Tot1->Fvit = fopen (NOME_FILE, "w+");
      Tot1->MAR = Tot1->VIT = Tot1->PER = NULL;
      Tot1->sbuf = malloc (Tot1->PawnMult);
      Tot1->vbuf = malloc (Tot1->PawnMult8);
      Tot1->mbuf = malloc (Tot1->PawnMult8);
      Tot1->pbuf = malloc (Tot1->PawnMult8);
      Tot1->rima_pro = malloc (1806 * sizeof (int));
      Tot1->vit_pro = malloc (1806 * sizeof (int));
      Tot1->per_pro = malloc (1806 * sizeof (int));
      Tot1->mar_pro = malloc (1806 * sizeof (int));
    }
  else
    {
      Tot1->data = malloc (Tot1->pro);
      int PR = RF * Tot1->PawnMult8;
      posix_memalign ((void*) &Tot1->MAR, 64, PR);
      posix_memalign ((void*) &Tot1->VIT, 64, PR);
      posix_memalign ((void*) &Tot1->PER, 64, PR);
      for (i = 0; i < PR; i++)
	Tot1->MAR[i] = Tot1->VIT[i] = Tot1->PER[i] = 0;
    }

  for (rf = 0; rf < RF; rf++)
    {
      int king = PawnFlag ? inverso_pedone_re[rf] : inverso_normale_re[rf];
      wK = king >> 6;
      bK = king & 63;
      if (PawnFlag)
	LOAD_re_fetta (Tot1, wK, bK, rf);
      if (Tot1->MEMORIA)
	{
	  Tot1->sbuf = Tot1->data + (rf * Tot1->PawnMult);
	  Tot1->mbuf = Tot1->MAR + (rf * Tot1->PawnMult8);
	  Tot1->vbuf = Tot1->VIT + (rf * Tot1->PawnMult8);
	  Tot1->pbuf = Tot1->PER + (rf * Tot1->PawnMult8);
	}
      else
	for (i = 0; i < Tot1->PawnMult8; i++)
	  Tot1->mbuf[i] = Tot1->vbuf[i] = Tot1->pbuf[i] = 0;
      for (i = 0; i < Tot1->PawnMult; i++)
	Tot1->sbuf[i] = VALU_INCOG;
      for (sq1 = SQ1; sq1 <= TER1; sq1++)
	for (sq2 = SQ2; sq2 <= TER2; sq2++)
	  for (sq3 = SQ3; sq3 <= TER3; sq3++)
	    for (sq4 = SQ4; sq4 <= TER4; sq4++)
	      {
		type_PiSq PiSq[1];
		if (pi[0] == pi[1] && sq1 <= sq2 && pi[0])
		  continue;
		if (pi[1] == pi[2] && sq2 <= sq3 && pi[1])
		  continue;
		if (pi[2] == pi[3] && sq3 <= sq4 && pi[2])
		  continue;
		PiSq->sq[0] = sq1;
		PiSq->sq[1] = sq2;
		PiSq->sq[2] = sq3;
		PiSq->sq[3] = sq4;
		PiSq->pi[0] = pi[0];
		PiSq->pi[1] = pi[1];
		PiSq->pi[2] = pi[2];
		PiSq->pi[3] = pi[3];
		PiSq->wK = wK;
		PiSq->bK = bK;
		PiSq->wtm = TRUE;
		if (wK == sq1 || wK == sq2 || bK == sq1 || bK == sq2 ||
		    wK == sq3 || bK == sq3 || wK == sq4 || bK == sq4
		    || (pi[1] && sq1 == sq2) || (pi[2] && sq1 == sq3)
		    || (pi[2] && sq2 == sq3) || (pi[3] && sq1 == sq4)
		    || (pi[3] && sq2 == sq4) || (pi[3] && sq3 == sq4)
		    || ((AttK[wK] | SqSet[wK]) & SqSet[bK]) ||
		    (pi[0] == BlockedPawn &&
		     (wK == sq1 + 8 || bK == sq1 + 8
		      || (pi[1] && sq1 + 8 == sq2)
		      || (pi[2] && sq1 + 8 == sq3)
		      || (pi[3] && sq1 + 8 == sq4))) ||
		    (pi[1] == BlockedPawn &&
		     (wK == sq2 + 8 || bK == sq2 + 8
		      || (pi[0] && sq2 + 8 == sq1)
		      || (pi[2] && sq2 + 8 == sq3)
		      || (pi[3] && sq2 + 8 == sq4))) ||
		    (pi[2] == BlockedPawn &&
		     (wK == sq3 + 8 || bK == sq3 + 8
		      || (pi[0] && sq3 + 8 == sq1)
		      || (pi[1] && sq3 + 8 == sq2)
		      || (pi[3] && sq3 + 8 == sq4))) ||
		    (pi[3] == BlockedPawn &&
		     (wK == sq4 + 8 || bK == sq4 + 8
		      || (pi[0] && sq4 + 8 == sq1)
		      || (pi[1] && sq4 + 8 == sq2)
		      || (pi[2] && sq4 + 8 == sq3))) ||
		    (pi[0] == BlockedPawn && pi[1] == BlockedPawn
		     && FILE (sq2) != FH && sq1 == sq2 + 1) ||
		    (pi[1] == BlockedPawn && pi[2] == BlockedPawn
		     && FILE (sq3) != FH && sq2 == sq3 + 1) ||
		    (pi[2] == BlockedPawn && pi[3] == BlockedPawn
		     && FILE (sq4) != FH && sq3 == sq4 + 1))		    
		  {
		    BITBOARD (POSITION, wK, bK, PiSq);
		    POSITION->wtm = TRUE;
		    PiSq->wtm = TRUE;
		    ott_indice (PiSq, &ci, &d, &re_fetta);
		    ROTTO (Tot1, ci, d);
		    goto AGAIN;
		  }
		if (pi[0])
		  POSITION->sq[sq1] = pi[0];
		if (pi[1])
		  POSITION->sq[sq2] = pi[1];
		if (pi[2])
		  POSITION->sq[sq3] = pi[2];
		if (pi[3])
		  POSITION->sq[sq4] = pi[3];
		if (pi[0] == wEnumB && SqSet[sq1] & DARK)
		  POSITION->sq[sq1] = wEnumBD;
		if (pi[1] == wEnumB && SqSet[sq2] & DARK)
		  POSITION->sq[sq2] = wEnumBD;
		if (pi[2] == wEnumB && SqSet[sq3] & DARK)
		  POSITION->sq[sq3] = wEnumBD;
		if (pi[3] == wEnumB && SqSet[sq4] & DARK)
		  POSITION->sq[sq4] = wEnumBD;
		if (pi[0] == bEnumB && SqSet[sq1] & DARK)
		  POSITION->sq[sq1] = bEnumBD;
		if (pi[1] == bEnumB && SqSet[sq2] & DARK)
		  POSITION->sq[sq2] = bEnumBD;
		if (pi[2] == bEnumB && SqSet[sq3] & DARK)
		  POSITION->sq[sq3] = bEnumBD;
		if (pi[3] == bEnumB && SqSet[sq4] & DARK)
		  POSITION->sq[sq4] = bEnumBD;
		if (pi[0] == BlockedPawn)
		  {
		    POSITION->sq[sq1] = wEnumP;
		    POSITION->sq[sq1 + 8] = bEnumP;
		  }
		if (pi[1] == BlockedPawn)
		  {
		    POSITION->sq[sq2] = wEnumP;
		    POSITION->sq[sq2 + 8] = bEnumP;
		  }
		if (pi[2] == BlockedPawn)
		  {
		    POSITION->sq[sq3] = wEnumP;
		    POSITION->sq[sq3 + 8] = bEnumP;
		  }
		if (pi[3] == BlockedPawn)
		  {
		    POSITION->sq[sq4] = wEnumP;
		    POSITION->sq[sq4 + 8] = bEnumP;
		  }
		POSITION->sq[wK] = wEnumK;
		POSITION->sq[bK] = bEnumK;
		POSITION->wtm = TRUE;
		BITBOARD (POSITION, wK, bK, PiSq);
		PiSq->wtm = TRUE;
		wBitboardOcc = wBitboardK | wBitboardQ | wBitboardR |
		               wBitboardB | wBitboardN | wBitboardP;
		bBitboardOcc = bBitboardK | bBitboardQ | bBitboardR
		               | bBitboardB | bBitboardN | bBitboardP;
		POSITION->OccupiedBW = wBitboardOcc | bBitboardOcc;
		POSITION->OccupiedL90 = SqSet[Left90[wK]] | SqSet[Left90[bK]];
		POSITION->OccupiedL45 = SqSet[Left45[wK]] | SqSet[Left45[bK]];
		POSITION->OccupiedR45 = SqSet[Right45[wK]] | SqSet[Right45[bK]];
		if (pi[0])
		  {
		    POSITION->OccupiedL90 |= SqSet[Left90[sq1]];
		    POSITION->OccupiedL45 |= SqSet[Left45[sq1]];
		    POSITION->OccupiedR45 |= SqSet[Right45[sq1]];
		    if (pi[0] == BlockedPawn)
		      {
			POSITION->OccupiedL90 |= SqSet[Left90[sq1 + 8]];
			POSITION->OccupiedL45 |= SqSet[Left45[sq1 + 8]];
			POSITION->OccupiedR45 |= SqSet[Right45[sq1 + 8]];
		      }
		  }
		if (pi[1])
		  {
		    POSITION->OccupiedL90 |= SqSet[Left90[sq2]];
		    POSITION->OccupiedL45 |= SqSet[Left45[sq2]];
		    POSITION->OccupiedR45 |= SqSet[Right45[sq2]];
		    if (pi[1] == BlockedPawn)
		      {
			POSITION->OccupiedL90 |= SqSet[Left90[sq2 + 8]];
			POSITION->OccupiedL45 |= SqSet[Left45[sq2 + 8]];
			POSITION->OccupiedR45 |= SqSet[Right45[sq2 + 8]];
		      }
		  }
		if (pi[2])
		  {
		    POSITION->OccupiedL90 |= SqSet[Left90[sq3]];
		    POSITION->OccupiedL45 |= SqSet[Left45[sq3]];
		    POSITION->OccupiedR45 |= SqSet[Right45[sq3]];
		    if (pi[2] == BlockedPawn)
		      {
			POSITION->OccupiedL90 |= SqSet[Left90[sq3 + 8]];
			POSITION->OccupiedL45 |= SqSet[Left45[sq3 + 8]];
			POSITION->OccupiedR45 |= SqSet[Right45[sq3 + 8]];
		      }
		  }
		if (pi[3])
		  {
		    POSITION->OccupiedL90 |= SqSet[Left90[sq4]];
		    POSITION->OccupiedL45 |= SqSet[Left45[sq4]];
		    POSITION->OccupiedR45 |= SqSet[Right45[sq4]];
		    if (pi[3] == BlockedPawn)
		      {
			POSITION->OccupiedL90 |= SqSet[Left90[sq4 + 8]];
			POSITION->OccupiedL45 |= SqSet[Left45[sq4 + 8]];
			POSITION->OccupiedR45 |= SqSet[Right45[sq4 + 8]];
		      }
		  }
		Mobility (POSITION);
		SetupPosition (POSITION, Tot1, PiSq);
	      AGAIN:
		POSITION->sq[wK] = POSITION->sq[bK] = 0;
		if (pi[0])
		  POSITION->sq[sq1] = 0;
		if (pi[1])
		  POSITION->sq[sq2] = 0;
		if (pi[2])
		  POSITION->sq[sq3] = 0;
		if (pi[3])
		  POSITION->sq[sq4] = 0;
		if (pi[0] == BlockedPawn)
		  POSITION->sq[sq1 + 8] = 0;
		if (pi[1] == BlockedPawn)
		  POSITION->sq[sq2 + 8] = 0;
		if (pi[2] == BlockedPawn)
		  POSITION->sq[sq3 + 8] = 0;
		if (pi[3] == BlockedPawn)
		  POSITION->sq[sq4 + 8] = 0;
	      }
      if (!Tot1->MEMORIA)
	{
	  int df;
	  fseek (Tot1->Frima, rf * Tot1->PawnMult, 0);
	  df = DISCO_FWRITE1 (Tot1->sbuf, 1, Tot1->PawnMult, Tot1->Frima);
	  Tot1->rima_pro[rf] = df;
	  fseek (Tot1->Fvit, rf * Tot1->PawnMult8, 0);
	  df = DISCO_FWRITE2 (Tot1->vbuf, 1, Tot1->PawnMult8, Tot1->Fvit);
	  Tot1->vit_pro[rf] = df;
	  fseek (Tot1->Fper, rf * Tot1->PawnMult8, 0);
	  df = DISCO_FWRITE2 (Tot1->pbuf, 1, Tot1->PawnMult8, Tot1->Fper);
	  Tot1->per_pro[rf] = df;
	  fseek (Tot1->Fmar, rf * Tot1->PawnMult8, 0);
	  df = DISCO_FWRITE2 (Tot1->mbuf, 1, Tot1->PawnMult8, Tot1->Fmar);
	  Tot1->mar_pro[rf] = df;
	}
    }
  if (!Tot1->MEMORIA)
    {
      free (Tot1->sbuf);
      fflush (Tot1->Frima);
      fflush (Tot1->Fvit);
      fflush (Tot1->Fper);
      fflush (Tot1->Fmar);
    }
  printf ("INIZ %s [%.2fs]\n",
	  Tot1->string, ((double) (GetClock () - Clock)) / 1000000.0);
}

static boolean MEMORIA = FALSE;
static void
TotalBaseBuild (RobboTotalBase * Tot1, RobboTotalBase * Tot2, int *pieces)
{
  int i, num;
  typePOS POSITION[1];
  POSITION->DYN_ROOT = malloc(MAXIMUM_PLY * sizeof(typeDYNAMIC));
  POSITION->DYN = POSITION->DYN_ROOT;
  popolare (POSITION, pieces, Tot1);
  if (!MEMORIA)
    iniz_una (Tot1);
  for (i = 0; i < 4; i++)
    if (pieces[i] & 0x7)
      pieces[i] ^= 8;
  popolare (POSITION, pieces, Tot2);
  Tot1->simm = Tot2->simm = FALSE;
  for (num = 0;; num++)
    {
      if (!fareRIMA (Tot2, num, Tot1) && 0) /* 0 ? */
	break;
      if (!fareMARCO (Tot1, num, Tot2))
	break;
    }
  for (num = 0;; num++)
    {
      if (!fareRIMA (Tot1, num, Tot2) && 0)
	break;
      if (!fareMARCO (Tot2, num, Tot1))
	break;
    }
  free (POSITION->DYN_ROOT);
}

static void
RobboBUILD_stesso (RobboTotalBase * Tot1, int *pieces)
{
  int num;
  typePOS POSITION[1];
  POSITION->DYN_ROOT = malloc(MAXIMUM_PLY * sizeof(typeDYNAMIC));
  POSITION->DYN = POSITION->DYN_ROOT;
  popolare (POSITION, pieces, Tot1);
  Tot1->simm = TRUE;
  if (!MEMORIA)
    iniz_una (Tot1);
  for (num = 0;; num++)
    {
      if (!fareRIMA (Tot1, num, Tot1) && 0)
	break;
      if (!fareMARCO (Tot1, num, Tot1))
	break;
    }
  free (POSITION->DYN_ROOT);
}

static boolean
eVIT (RobboTotalBase * tb, int fetta, uint64 PositionNumber)
{
  if (tb->MEMORIA)
    return emarco (tb->VIT, fetta * tb->PawnMult8 * 8 + PositionNumber);
  return emarco (tb->vbuf, PositionNumber);
}

#define ZOBRIST(rf, PositionNumber) \
  ( ( (rf) * 123456789 + (PositionNumber) * 98764321 + \
      ( (rf) * (PositionNumber) ) ) & EMASK)

uint64 *RICERCA, EMASK;

static void
nuovo_archivio (uint64 ip, uint64 wK)
{
  int ok = ZOBRIST ((ip >> 32), (ip & 0xffffffff)), k = ok;
  while (RICERCA[k])
    {
      k++;
      if (k == (EMASK + 1))
	k = 0;
    }
  RICERCA[k] = ip | (wK << 48);
}

static void
iniz_supp (FILE * F, uint64 pro)
{
  uint64 i;
  uint64 wK = 0, ip;
  pro = 3 * (pro + 10) / 2;
  pro = (1 << (1 + BSR (pro)));
  EMASK = pro - 1;
  RICERCA = malloc (pro * 8);
  for (i = 0; i < pro; i++)
    RICERCA[i] = 0;
  for (i = 0; ; i++)
    {
      if (!fread (&ip, 8, 1, F))
	break;
      if (BSR (ip) > 56)
	{
	  wK = (ip >> 32) & 65535;
	  continue;
	}
      nuovo_archivio (ip, wK);
    }
}

static int
ric (int rf, int PositionNumber)
{
  int k = ZOBRIST (rf, PositionNumber);
  uint64 n = PositionNumber + (((uint64) rf) << 32);
  while (1)
    {
      uint64 v = RICERCA[k];
      if ((v & 0xffffffffffff) == n)
	return (v >> 48);
      if (v == 0)
	{
	  printf ("MALATO (supp)\n");
	  exit (1);
	}
      k = k + 1;
      if (k == (EMASK + 1))
	k = 0;
    }
}

#define BLOCCO_PRO 65536
#define uBWT 5

static void
supp_42_iniz (RobboTotalBase * tb, uint64 * supp_conto)
{
  uint64 n = ftell (tb->Fsupp) >> 3;
  uint64 ip;
  FILE *file[42];
  int i, j, L = tb->PEDONE ? 43 : 11;
  char NOME_FILE[1024];
  fseek (tb->Fsupp, 0, 0);
  for (j = 0; j < 42; j++)
    {
      sprintf (NOME_FILE, "%sSUPP%d.%s", tb->DIR_NOME, j, tb->string);
      file[j] = fopen (NOME_FILE, "w");
      supp_conto[j] = 0;
    }
  for (i = 0; i < n; i++)
    {
      fread (&ip, 8, 1, tb->Fsupp);
      if (BSR (ip) > 56)
	{
	  for (j = 0; j < 42; j++)
	    fwrite (&ip, 8, 1, file[j]);
	  continue;
	}
      fwrite (&ip, 8, 1, file[(ip >> 32) / L]);
      supp_conto[(ip >> 32) / L]++;
    }
  for (j = 0; j < 42; j++)
    fclose (file[j]);
  fclose (tb->Fsupp);
  sprintf (NOME_FILE, "%sSUPP.%s", tb->DIR_NOME, tb->string);
  remove (NOME_FILE);
}

static void
fine_rtb_memoria (RobboTotalBase * tb)
{
  uint64 u = 0, PositionNumber;
  int rf, RF = tb->PEDONE ? 1806 : 462;
  FILE *F;
  uint64 LIMITE = RF * tb->PawnMult;
  uint32 v = 0;
  char NOME_FILE[1024];
  uint32 n = BLOCCO_PRO | (uBWT << 28);
  int L = tb->PEDONE ? 43 : 11;
  uint64 supp_conto[42];
  boolean SUPP = (tb->Fsupp != NULL);
  if (SUPP)
    supp_42_iniz (tb, supp_conto);
  for (rf = 0; rf < RF; rf++)
  {
    if (SUPP && (rf % L) == 0)
      {
	sprintf (NOME_FILE, "%sSUPP%d.%s", tb->DIR_NOME, rf / L, tb->string);
	F = fopen (NOME_FILE, "r");
	if (rf != 0)
	  free (RICERCA);
	iniz_supp (F, supp_conto[rf / L]);
	fclose (F);
	remove (NOME_FILE);
      }
    for (PositionNumber = 0; PositionNumber < tb->PawnMult;
	 PositionNumber++, u++)
      {
	if (tb->data[u] == VALU_ROTTO)
	  tb->data[u] = dROTT;
	else if (eVIT (tb, rf, PositionNumber))
	  tb->data[u] = dVITT;
	else if (tb->data[u] <= MASSIMO_RIMA)
	  tb->data[u] = dPATT;
	else if (tb->data[u] == PERD_FINE)
	  tb->data[u] = ric (rf, PositionNumber) + dPERD0;
	else
	  tb->data[u] -= PRIMERA_PERDITA - dPERD0;
      }
  }
  if (SUPP)
    free (RICERCA);
  tb->indici = malloc (sizeof (uint32) * (2 + LIMITE / BLOCCO_PRO));
  for (u = 0; u < LIMITE; u += BLOCCO_PRO)
    tb->indici[++v] =
      compressa (tb->data + u, MIN (BLOCCO_PRO, LIMITE - u), uBWT);
  tb->indici[0] = 0;
  for (u = 0; u < v; u++)
    tb->indici[u + 1] += tb->indici[u];
  v++;
  sprintf (NOME_FILE, "%s%s%s", tb->DIR_NOME, COMPRESSA_PREFISSO, tb->string);
  F = fopen (NOME_FILE, "w");
  /* Header 4 bytes 0xca 0x7f 0x0b 0xaa */
  fputc (0xca, F);
  fputc (0x7f, F);
  fputc (0x0b, F);
  fputc (0xaa, F);
  /* Header block size */
  fputc (n & 255, F);
  fputc ((n >> 8) & 255, F);
  fputc ((n >> 16) & 255, F);
  fputc ((n >> 24) & 255, F);
  /* Header 4 null bytes */
  fputc (0, F);
  fputc (0, F);
  fputc (0, F);
  fputc (0, F);
  /* Header indici count */
  fputc (v & 255, F);
  fputc ((v >> 8) & 255, F);
  fputc ((v >> 16) & 255, F);
  fputc ((v >> 24) & 255, F);
  fwrite (tb->indici, sizeof (uint32), v, F); /* ENDIAN */
  fclose (F);
  v = 0;
  sprintf (NOME_FILE, "%s%s%s", tb->DIR_NOME, COMPRESSA_PREFISSO + 1,
	   tb->string);
  F = fopen (NOME_FILE, "w");
  for (u = 0; u < LIMITE; u += BLOCCO_PRO, v++)
    fwrite (tb->data + u, 1,
	    tb->indici[v + 1] - tb->indici[v], F);
  free (tb->data);
  free (tb->VIT);
  free (tb->PER);
  free (tb->MAR);
  fclose (F);
  free (tb->indici);
}

#define fff(TotalBase, x) \
 ric ( (x) / TotalBase->PawnMult, (x) % TotalBase->PawnMult )
static void
fine_disco (RobboTotalBase * tb)
{
  char NOME_FILE[1024];
  FILE *F;
  uint64 w, v = 0, i, t, u;
  uint64 LIMITE = tb->PawnMult * (tb->PEDONE ? 1806 : 462);
  uint32 n = BLOCCO_PRO | (uBWT << 28);
  fclose (tb->Fper);
  fclose (tb->Fmar);
  free (tb->mbuf);
  free (tb->pbuf);
  free (tb->vbuf);
  sprintf (NOME_FILE, "%sPERD.%s", tb->DIR_NOME, tb->string);
  remove (NOME_FILE);
  sprintf (NOME_FILE, "%sMARC.%s", tb->DIR_NOME, tb->string);
  remove (NOME_FILE);
  tb->sbuf = malloc (tb->PawnMult + 65536);
  tb->vbuf = malloc (tb->PawnMult8 + 8192);
  for (i = 0; i < tb->PawnMult8 + 8192; i++)
    tb->vbuf[i] = 0;
  fseek (tb->Frima, 0, 0);
  fseek (tb->Fvit, 0, 0);
  tb->indici = malloc (sizeof (uint32) * (2 + LIMITE / BLOCCO_PRO));
  sprintf (NOME_FILE, "%s%s%s", tb->DIR_NOME, COMPRESSA_PREFISSO + 1,
	   tb->string);
  F = fopen (NOME_FILE, "w");
  boolean SUPP = (tb->Fsupp != NULL);
  uint64 supp_conto[42];
  if (SUPP)
    supp_42_iniz (tb, supp_conto);
  int L = tb->PEDONE ? 43 : 11;
  int ss = 0, rf = 0;
  FILE *F2;
  for (u = 0; u < LIMITE; u += tb->PawnMult, rf++)
    {
      if (SUPP && (rf % L) == 0)
      {
	sprintf (NOME_FILE, "%sSUPP%d.%s", tb->DIR_NOME, rf / L, tb->string);
	F2 = fopen (NOME_FILE, "r");
	if (rf != 0)
	  free (RICERCA);
	iniz_supp (F2, supp_conto[rf / L]);
	fclose (F2);
	remove (NOME_FILE);
      }
      fseek (tb->Frima, u, 0);
      DISCO_FREAD1
	(ss + tb->sbuf, 1, tb->PawnMult, tb->Frima,
	 tb->rima_pro[u / tb->PawnMult] );
      fseek (tb->Fvit, u / 8, 0);
      DISCO_FREAD2
	(ss / 8 + tb->vbuf, 1, tb->PawnMult8, tb->Fvit,
	 tb->vit_pro[u / tb->PawnMult]);
      w = v;
      for (i = 0; i < tb->PawnMult; i++)
	{
	  if (tb->sbuf[ss + i] == VALU_ROTTO)
	    tb->sbuf[ss + i] = dROTT;
	  else if (eVIT (tb, 0, ss + i))
	    tb->sbuf[ss + i] = dVITT;
	  else if (tb->sbuf[ss + i] <= MASSIMO_RIMA)
	    tb->sbuf[ss + i] = dPATT;
	  else if (tb->sbuf[ss + i] == PERD_FINE)
	    tb->sbuf[ss + i] = fff (tb, u + i) + dPERD0;
	  else
	    tb->sbuf[ss + i] -= PRIMERA_PERDITA - dPERD0;
	}
      for (t = 0; t + BLOCCO_PRO <= ss + tb->PawnMult; t += BLOCCO_PRO)
	tb->indici[++v] =
	  compressa (tb->sbuf + t, BLOCCO_PRO, uBWT);
      ss = (ss + tb->PawnMult) - t;
      for (t = 0; w < v; t += BLOCCO_PRO, w++)
	fwrite (tb->sbuf + t, 1, tb->indici[w + 1], F);
      for (i = 0; i < ss; i++)
	tb->sbuf[i] = tb->sbuf[t + i];
      for (i = 0; i < ss / 8; i++)
	tb->vbuf[i] = tb->vbuf[t / 8 + i];
    }
  if (ss)
    {
      tb->indici[++v] =
	compressa (tb->sbuf + t, ss, uBWT);
      fwrite (tb->sbuf + t, 1, tb->indici[v], F);
    }

  fclose (tb->Frima);
  fclose (tb->Fvit);
  fclose (F);
  if (SUPP)
    free (RICERCA);
  free (tb->sbuf);
  free (tb->vbuf);
  sprintf (NOME_FILE, "%sRIMA.%s", tb->DIR_NOME, tb->string);
  remove (NOME_FILE);
  sprintf (NOME_FILE, "%sVITT.%s", tb->DIR_NOME, tb->string);
  remove (NOME_FILE);
  tb->indici[0] = 0;
  for (u = 0; u < v; u++)
    tb->indici[u + 1] += tb->indici[u];
  v++;
  sprintf (NOME_FILE, "%s%s%s", tb->DIR_NOME, COMPRESSA_PREFISSO, tb->string);
  F = fopen (NOME_FILE, "w");
  fputc (0xca, F);
  fputc (0x7f, F);
  fputc (0x0b, F);
  fputc (0xaa, F);
  fputc (n & 255, F);
  fputc ((n >> 8) & 255, F);
  fputc ((n >> 16) & 255, F);
  fputc ((n >> 24) & 255, F);
  fputc (0, F);
  fputc (0, F);
  fputc (0, F);
  fputc (0, F);
  fputc (v & 255, F);
  fputc ((v >> 8) & 255, F);
  fputc ((v >> 16) & 255, F);
  fputc ((v >> 24) & 255, F);
  fwrite (tb->indici, sizeof (uint32), v, F); /* ENDIAN */
  free (tb->indici);
  fclose (F);
  free (tb->rima_pro);
  free (tb->vit_pro);
  free (tb->per_pro);
  free (tb->mar_pro);
}

static void
TotalBaseMake (RobboTotalBase * Tot1, RobboTotalBase * Tot2, int *pi)
{
  Tot1->MEMORIA = Tot2->MEMORIA = MEMORIA;
  if (Tot1 == Tot2)
    RobboBUILD_stesso (Tot1, pi);
  else
    TotalBaseBuild (Tot1, Tot2, pi);
  if (!MEMORIA)
    fine_una ();
  else
    {
      fine_rtb_memoria (Tot1);
      if (Tot1 != Tot2)
	fine_rtb_memoria (Tot2);
      return;
    }
  fine_disco (Tot1);
  if (Tot1 != Tot2)
    fine_disco (Tot2);
}

void
NOME_INVERSO (char *I, char *O)
{
  int i;
  boolean x;
  for (i = 0; i < 4; i++)
    O[i] = (I[i] == '0' || !I[i] || I[i] == 'Z') ? I[i] : I[i] ^ 32;
  nome_canonico (O, &x);
}

void
RTBfare (char *nome, boolean simm)
{
  int n, i, rt1, rt2, PI[4];
  char inverso_nome[64], DIRECTORY[1024], NOME[64];
  uint64 Clock = GetClock ();
  boolean x;
  for (i = 0; i < 8; i++)
    NOME[i] = 0;
  n = nome_canonico (nome, &x);
  RobboTotal_sott (nome);
  strcpy (NOME, nome);
  if (NOME[0] == 'K' || NOME[0]=='k')
    un_windows (NOME);
  for (i = 0; i < 4; i++)
    if (NOME[i] == '0')
      NOME[i] = 0;
  for (i = 3; NOME[i - 2]; i++);
  sprintf (DIRECTORY, "%s/%d/", TOTAL_BASE_DIRECTORY, i);
  RobboTotal_add (TABLE_TOTAL_BASES + NUM_TOTAL_BASES, nome, DIRECTORY);
  NOME_INVERSO (nome, inverso_nome);
  inverso_nome[n] = 0;
  if (!simm)
    {
      RobboTotal_sott (inverso_nome);
      RobboTotal_add (TABLE_TOTAL_BASES + NUM_TOTAL_BASES, inverso_nome, DIRECTORY);
    }
  rt2 = NUM_TOTAL_BASES - 1;
  if (simm)
    rt1 = NUM_TOTAL_BASES - 1;
  else
    rt1 = NUM_TOTAL_BASES - 2;
  for (i = 0; i < 4; i++)
    switch (nome[i])
      {
      case 'Q':
	PI[i] = wEnumQ;
	break;
      case 'q':
	PI[i] = bEnumQ;
	break;
      case 'R':
	PI[i] = wEnumR;
	break;
      case 'r':
	PI[i] = bEnumR;
	break;
      case 'B':
	PI[i] = wEnumB;
	break;
      case 'b':
	PI[i] = bEnumB;
	break;
      case 'N':
	PI[i] = wEnumN;
	break;
      case 'n':
	PI[i] = bEnumN;
	break;
      case 'P':
	PI[i] = wEnumP;
	break;
      case 'p':
	PI[i] = bEnumP;
	break;
      case 'Z':
	PI[i] = BlockedPawn;
	break;
      default:
	PI[i] = 0;
      }
  TotalBaseMake (TABLE_TOTAL_BASES + rt1, TABLE_TOTAL_BASES + rt2, PI);
  RobboTotal_sott (nome);
  if (!simm)
    RobboTotal_sott (inverso_nome);
  RobboTotal_registro (nome, DIRECTORY);
  if (!simm)
    RobboTotal_registro (inverso_nome, DIRECTORY);
  printf ("Fine %s: %.2fs\n", nome,
	  ((double) (GetClock () - Clock)) / 1000000.0);
  fflush (stdout);
}

void
TotalBaseInit ()
{
  int pi1, pi2, pi3, pi4;
  int i;
  InitTotalBaseUtility (TRUE);
  NUM_TOTAL_BASES = 0;
  for (pi1 = 0; pi1 < 16; pi1++)
    for (pi2 = 0; pi2 < 16; pi2++)
      for (pi3 = 0; pi3 < 16; pi3++)
	for (pi4 = 0; pi4 < 16; pi4++)
	  TotalBaseTable[pi1][pi2][pi3][pi4] = -1;
  TABLE_TOTAL_BASES = malloc (MAX_TABLES * sizeof (RobboTotalBase));
  for (i = 0; i < MAX_TABLES; i++)
    (TABLE_TOTAL_BASES + i)->Fdata = NULL;
  InitInitTotalBaseCache (64);
}

#include <strings.h>
#define MAX_NUM 4

static void
simmetria (char *C, char *SIM)
{
  int i;
  for (i = 0; C[i]; i++)
    SIM[i] = C[i] ^ 32;
  for (i = 0; C[i]; i++)
    if (SIM[i] == 'z') SIM[i] ^= 32;
  SIM[i] = 0;
}

#define RECURSE(C, B) \
 if (RobboTotal_scop (C) == -1) \
  { if (B) { printf ("Recursing %s\n", C); TotalBasePrepare (C, B); } \
    else { printf ("Needed dependency %s unavailable\n", C); return; } }

static void
TotalBasePrepare (char *AB, boolean B)
{
  int i, j, n;
  boolean simm = FALSE;
  char A[16], C[16], SIM[16], PEZb[8] = "QRBN", PEZn[8] = "qrbn";
  strcpy (A, AB);
  if (A[0] == 'K' || A[0] == 'k')
    un_windows (A);
  n = nome_canonico (A, &simm);
  strcpy (C, A);
  for (i = 0; i < n; i++)
    {
      if (C[i] == 'P')
	{
	  for (j = 0; j < 4; j++)
	    {
	      C[i] = PEZb[j];
	      RECURSE (C, B);
	      simmetria (C, SIM);
	      RECURSE (SIM, B);
	    }
	  C[i] = 'P';
	}
      if (C[i] == 'p')
	{
	  for (j = 0; j < 4; j++)
	    {
	      C[i] = PEZn[j];
	      RECURSE (C, B);
	      simmetria (C, SIM);
	      RECURSE (SIM, B);
	    }
	  C[i] = 'p';
	}
      if (C[i] == 'Z')
	{
	  C[i] = 'P';
	  RECURSE (C, B);
	  simmetria (C, SIM);
	  RECURSE (SIM, B);
	  for (j = 0; j < n; j++)
	    {
	      char u = C[j];
	      if (i == j || (C[j] >= 'A' && C[j] <= 'Z'))
		continue;
	      C[j] = 'p';
	      RECURSE (C,B);
	      simmetria (C, SIM);
	      RECURSE (SIM, B);
	      C[j] = u;
	    }
	  C[i] = 'p';
	  RECURSE (C, B);
	  simmetria (C, SIM);
	  RECURSE (SIM, B);
	  for (j = 0; j < n; j++)
	    {
	      char u = C[j];
	      if (i == j || (C[j] >= 'a' && C[j] <= 'z'))
		continue;
	      C[j] = 'P';
	      RECURSE (C,B);
	      simmetria (C, SIM);
	      RECURSE (SIM, B);
	      C[j] = u;
	    }
	  C[i] = 'Z';
	}
    }
  for (i = 0; i < n; i++)
    {
      C[i] = A[n - 1];
      C[n - 1] = 0;
      RECURSE (C, B);
      simmetria (C, SIM);
      RECURSE (SIM, B);
      C[i] = A[i];
    }
  RTBfare (A, simm);
}

static void reindici (char *A) /* hiperindici */
{
  char C[16], NOME[64], DIRECTORY[1024];
  boolean B = FALSE;
  int i;
  strcpy (C, A);
  if (C[0] == 'K' || C[0] == 'k')
    un_windows (C);
  nome_canonico (C, &B);
  strcpy (NOME, C);
  for (i = 0; i < 4; i++)
    if (NOME[i] == '0')
      NOME[i] = 0;
  for (i = 3; NOME[i - 2]; i++);
  sprintf (DIRECTORY, "%s/%d/", TOTAL_BASE_DIRECTORY, i);
  RobboTotal_registro (C, DIRECTORY);
  int k, v = RobboTotal_scop (C);
  if (v == -1)
    {
      printf ("File not found %s\n", A);
      return;
    }
  RobboTotalBase *rtb;
  rtb = (TABLE_TOTAL_BASES + v);
  if (rtb->BLOCCO_pro == 0x100000)
    {
      printf ("Done already reindici %s\n", A);
      return;
    }

  uint64 rf = rtb->PEDONE ? 1806 : 462;
  uint64 pr = rtb->PawnMult;
  uint64 PR = pr * rf;
  uint8 *Z;
  Z = malloc(65536);
  int j, J = (PR && 65535) + (PR >> 16);

  uint32 *p;
  p = rtb->indici;
  char STR[1024];
  sprintf (STR, "%s%s%s", rtb->DIR_NOME, COMPRESSA_PREFISSO + 1, rtb->string);
  rtb->Fdata = fopen (STR, "r");

  FILE *NEW_INDEX;
  char NI_STR[1024];
  sprintf (NI_STR, "%sNEW%s%s", rtb->DIR_NOME, COMPRESSA_PREFISSO, rtb->string);
  NEW_INDEX = fopen (NI_STR, "w");
  FILE *NEW_DATA;
  char ND_STR[1024];
  sprintf (ND_STR, "%sNEW%s%s", rtb->DIR_NOME, COMPRESSA_PREFISSO + 1, rtb->string);
  NEW_DATA = fopen (ND_STR, "w");

  fputc (0xca, NEW_INDEX);
  fputc (0x7f, NEW_INDEX);
  fputc (0x0b, NEW_INDEX);
  fputc (0xaa, NEW_INDEX);
  uint32 by = (rtb->BWT << 28) | 0x100000; /* hiperindici */
  fputc (by & 0xff, NEW_INDEX);
  fputc ((by >> 8) & 0xff, NEW_INDEX);
  fputc ((by >> 16) & 0xff, NEW_INDEX);
  fputc ((by >> 24) & 0xff, NEW_INDEX);
  fputc (0, NEW_INDEX);
  fputc (0, NEW_INDEX);
  fputc (0, NEW_INDEX);
  fputc (0, NEW_INDEX);
  J--;
  by = 2 + (J >> 4); /* num_indici */
  printf ("Force (%d+1) indici to (%d+1)\n", J, by - 1);
  fputc (by & 0xff, NEW_INDEX);
  fputc ((by >> 8) & 0xff, NEW_INDEX);
  fputc ((by >> 16) & 0xff, NEW_INDEX);
  fputc ((by >> 24) & 0xff, NEW_INDEX);
  sint32 w = 0;
  for (j = 0; j + 0x10 < J; j += 0x10)
    {
      fwrite (&w, 4 , 1, NEW_INDEX);
      w += p[j + 0x10] - p[j] + 128;
    }
  fwrite (&w, 4, 1, NEW_INDEX);
  w += p[J] - p[j] + 128;
  fwrite (&w, 4, 1, NEW_INDEX);

  fclose (NEW_INDEX);
  for (j = 0; j + 0x10 < J; j += 0x10)
    {
      for (k = 0; k < 0x10; k++)
	{
	  w = 128 + p[j + k] - p[j];
	  fwrite (&w, 4, 1, NEW_DATA);
	  w = p[j + k + 1] - p[j + k];
	  fwrite (&w, 4, 1, NEW_DATA);
	}
      for (k = 0; k < 0x10; k++)
	{
	  w = p[j + k + 1] - p[j + k];
	  fread (Z, 1, w, rtb->Fdata);
	  fwrite (Z, 1, w, NEW_DATA);
	}
    }
  for (k = 0; k < 0x10; k++)
    {
      if (j + k >= J)
	w = 0;
      else
	w = 128 + p[j + k] - p[j];
      fwrite (&w, 4, 1, NEW_DATA);
      if (j + k >= J)
	w = 0;
      else
	w = p[j + k + 1] - p[j + k];
      fwrite (&w, 4, 1, NEW_DATA);
    }
  for (k = 0; k < 0x10; k++)
    {
      if (j + k < J)
	{
	  w = p[j + k + 1] - p[j + k];
	  fread (Z, 1, w, rtb->Fdata);
	  fwrite (Z, 1, w, NEW_DATA);
	}
    }
  fclose (NEW_DATA);
  fclose (rtb->Fdata);
}

static void stats (char *A) /* fail hiperindici compatible */
{
  char C[16], NOME[64], DIRECTORY[1024];
  boolean B = FALSE;
  int i;
  strcpy (C, A);
  if (C[0] == 'K' || C[0] == 'k')
    un_windows (C);
  nome_canonico (C, &B);
  strcpy (NOME, C);
  for (i = 0; i < 4; i++)
    if (NOME[i] == '0')
      NOME[i] = 0;
  for (i = 3; NOME[i - 2]; i++);
  sprintf (DIRECTORY, "%s/%d/", TOTAL_BASE_DIRECTORY, i);
  RobboTotal_registro (C, DIRECTORY);
  int k, v = RobboTotal_scop (C);
  if (v == -1)
    {
      printf ("File not found %s\n", A);
      return;
    }
  uint64 c[256];
  for (i = 0; i < 256; i++)
    c[i] = 0;
  uint64 rf = (TABLE_TOTAL_BASES + v)->PEDONE ? 1806 : 462;
  uint64 pr = (TABLE_TOTAL_BASES + v)->PawnMult;
  uint64 PR = pr * rf;
  uint8 *Y, *Z;
  Y = malloc(65536);
  Z = malloc(65536);
  int j, J = (PR && 65535) + (PR >> 16);

  uint32 *p;
  p = (TABLE_TOTAL_BASES + v)->indici;
  char STR[1024];
  sprintf (STR, "%s%s%s", (TABLE_TOTAL_BASES + v)->DIR_NOME,
	   COMPRESSA_PREFISSO + 1, (TABLE_TOTAL_BASES + v)->string);
  (TABLE_TOTAL_BASES + v)->Fdata = fopen (STR, "r");
  for (j = 0; j < J; j++)
    {
      int w = p[j+1] - p[j];
      fread (Z, 1, w, (TABLE_TOTAL_BASES + v)->Fdata);
      int d = blocco_decompressa (Y, Z, w, (TABLE_TOTAL_BASES + v)->TYPE);
      for (k = 0; k < d; k++)
	c[Y[k]]++;
    }
  for (j = 0; j < 256; j++)
    if (c[j])
      printf ("%d %lld\n", j, c[j]);
  fclose ((TABLE_TOTAL_BASES + v)->Fdata);
}

void
argomenti_lavora (int n, char **A)
{
  int i, b = 0;
  char STRUT[1024][16], OTT[1024];
  boolean LOAD3 = TRUE, LOAD4 = TRUE, LOAD5 = TRUE, LOAD6 = TRUE,
    LOAD = TRUE, RECURSE = FALSE;
  boolean TRIPLE_LOAD3 = TRUE, TRIPLE_LOAD4 = TRUE,
    TRIPLE_LOAD5 = TRUE, TRIPLE_LOAD6 = TRUE, TRIPLE_LOAD = TRUE;
  boolean RobboTripleBase = FALSE, STATS = FALSE, REINDICI = FALSE;
  for (i = 1; i < n; i++)
    {
      if (!strcmp (A[i], "--mem"))
	{
	  MEMORIA = TRUE;
	  continue;
	}
      if (!strcmp (A[i], "--reindici"))
	{
	  REINDICI = TRUE;
	  continue;
	}
      if (!strcmp (A[i], "--stats"))
	{
	  STATS = TRUE;
	  continue;
	}
      if (!strcmp (A[i], "--RobboTripleBase"))
	{
	  RobboTripleBase = TRUE;
	  continue;
	}
      if (!strcmp (A[i], "--recurse"))
	{
	  RECURSE = TRUE;
	  continue;
	}
      if (!strcmp (A[i], "--noload"))
	{
	  LOAD = FALSE;
	  continue;
	}
      if (!strcmp (A[i], "--noload-triple"))
	{
	  TRIPLE_LOAD = FALSE;
	  continue;
	}
      if (!strcmp (A[i], "--noload3"))
	{
	  LOAD3 = FALSE;
	  continue;
	}
      if (!strcmp (A[i], "--noload4"))
	{
	  LOAD4 = FALSE;
	  continue;
	}
      if (!strcmp (A[i], "--noload5"))
	{
	  LOAD5 = FALSE;
	  continue;
	}
      if (!strcmp (A[i], "--noload6"))
	{
	  LOAD6 = FALSE;
	  continue;
	}
      strcpy (STRUT[b++], A[i]);
    }
  if (LOAD)
    {
      if (LOAD3)
	{
	  sprintf (OTT, "%s/3", TOTAL_BASE_DIRECTORY);
	  GetTotalBase (OTT);
	}
      if (LOAD4)
	{
	  sprintf (OTT, "%s/4", TOTAL_BASE_DIRECTORY);
	  GetTotalBase (OTT);
	}
      if (LOAD5)
	{
	  sprintf (OTT, "%s/5", TOTAL_BASE_DIRECTORY);
	  GetTotalBase (OTT);
	}
      if (LOAD6)
	{
	  sprintf (OTT, "%s/6", TOTAL_BASE_DIRECTORY);
	  GetTotalBase (OTT);
	}
    }
  if (TRIPLE_LOAD)
    {
      if (TRIPLE_LOAD3)
	{
	  sprintf (OTT, "%s/2", TRIPLE_DIR);
	  GetTripleBase (OTT);
	}
      if (TRIPLE_LOAD3)
	{
	  sprintf (OTT, "%s/3", TRIPLE_DIR);
	  GetTripleBase (OTT);
	}
      if (TRIPLE_LOAD4)
	{
	  sprintf (OTT, "%s/4", TRIPLE_DIR);
	  GetTripleBase (OTT);
	}
      if (TRIPLE_LOAD5)
	{
	  sprintf (OTT, "%s/5", TRIPLE_DIR);
	  GetTripleBase (OTT);
	}
      if (TRIPLE_LOAD6)
	{
	  sprintf (OTT, "%s/6", TRIPLE_DIR);
	  GetTripleBase (OTT);
	}
    }
  if (RobboTripleBase)
    {
      for (i = 0; i < b; i++)
	triple_disposto (STRUT[i], RECURSE);
      return;
    }
  if (STATS)
    {
      for (i = 0; i < b; i++)
	stats (STRUT[i]);
      return;
    }
  if (REINDICI)
    {
      for (i = 0; i < b; i++)
	reindici (STRUT[i]);
      return;
    }
  for (i = 0; i < b; i++)
    TotalBasePrepare (STRUT[i], RECURSE);
}


int
main (int argc, char **argv)
{
  InitArrays ();
  TotalBaseInit ();
  //  POSITION->DYN = POSITION->DYN_ROOT;
  iniz_vario ();
  strcpy (TOTAL_BASE_DIRECTORY, "RobboTotalBase");
  strcpy (TRIPLE_DIR, "RobboTripleBase");
  INIT_TRIPLE_BASE ();
  argomenti_lavora (argc, argv);
  exit (0);
}
