
#include "RobboLito.h"
#include "RobboTotalBase.h"

#define TOTAL_CACHE_PER 65536
static uint8 ***TotalBaseCache = NULL;
uint8 *BLOCCO; /* SMP ? */ /* need 1MB+128 for hiperindici */
static uint64 *CACHE_INFO[4];
static uint64 TB_CACHE_COUNT = 0;

int SetTotalBaseCache (int mb)
{
  int i, j;
  mb = 1 << BSR (mb);
  TB_CACHE_COUNT = mb << 2;
  for (i = 0; i < 4; i++)
    if (CACHE_INFO[i])
      free (CACHE_INFO[i]);
  for (i = 0; i < 4; i++)
    if (TotalBaseCache[i])
      free (TotalBaseCache[i]);  
  CACHE_INFO[0] = malloc (TB_CACHE_COUNT * sizeof (uint64));
  CACHE_INFO[1] = malloc (TB_CACHE_COUNT * sizeof (uint64));
  CACHE_INFO[2] = malloc (TB_CACHE_COUNT * sizeof (uint64));
  CACHE_INFO[3] = malloc (TB_CACHE_COUNT * sizeof (uint64));
  TotalBaseCache[0] = malloc (TB_CACHE_COUNT * sizeof (uint8 *));
  TotalBaseCache[1] = malloc (TB_CACHE_COUNT * sizeof (uint8 *));
  TotalBaseCache[2] = malloc (TB_CACHE_COUNT * sizeof (uint8 *));
  TotalBaseCache[3] = malloc (TB_CACHE_COUNT * sizeof (uint8 *));
  for (j = 0; j < 4; j++)
    for (i = 0; i < TB_CACHE_COUNT; i++)
      TotalBaseCache[j][i] = NULL;
  for (j = 0; j < 4; j++)
    for (i = 0; i < TB_CACHE_COUNT; i++)
      CACHE_INFO[j][i] = 0xffffffff;
  printf ("TotalBaseCache is %dmb + (1mb)\n", mb);
  return mb;
}

void InitInitTotalBaseCache (uint64 mb)
{
  TotalBaseCache = malloc (4 * sizeof (uint8 **));
#if 0
  BLOCCO = malloc (TOTAL_CACHE_PER); /* for hiperindici */
#else
  BLOCCO = malloc (128 + 16 * TOTAL_CACHE_PER); /* for hiperindici */
#endif
  CACHE_INFO[0] = CACHE_INFO[1] = CACHE_INFO[2] = CACHE_INFO[3] = NULL;
  TotalBaseCache[0] = TotalBaseCache[1] =
    TotalBaseCache[2] = TotalBaseCache[3] = NULL;
  SetTotalBaseCache (mb);
}

#define GetCache0(a,b) ( (123 * (a) + 321 * (b) ) & ( TB_CACHE_COUNT - 1) )
#define GetCache1(a,b) ( (179 * (a) + 557 * (b) ) & ( TB_CACHE_COUNT - 1) )
#define GetCache2(a,b) ( (671 * (a) + 409 * (b) ) & ( TB_CACHE_COUNT - 1) )
#define GetCache3(a,b) ( (773 * (a) + 187 * (b) ) & ( TB_CACHE_COUNT - 1) )

static uint32 espul_conto = 0;
static int fc = 0;
static uint8* scopPILA (RobboTotalBase* tb, uint64 PositionCount)
{
  uint64 v, n = tb->num, zo = PositionCount / TOTAL_CACHE_PER,
    ci = (n << 32) | zo, ZO;
  int h[4], e;
  int i;
  uint8* BPTR;
  h[0] = GetCache0 (n, zo);
  if (CACHE_INFO[0][h[0]] == ci)
    return TotalBaseCache[0][h[0]];
  h[1] = GetCache1 (n, zo);
  if (CACHE_INFO[1][h[1]] == ci)
    return TotalBaseCache[1][h[1]];
  h[2] = GetCache2 (n, zo);
  if (CACHE_INFO[2][h[2]] == ci)
    return TotalBaseCache[2][h[2]];
  h[3] = GetCache3 (n, zo);
  if (CACHE_INFO[3][h[3]] == ci)
    return TotalBaseCache[3][h[3]];
  espul_conto++;
  e = 0;
  for (i = 0; i < 16; i++)
    e += (espul_conto >> i);
  e = e & 3;
  if (TotalBaseCache[e][h[e]])
    v = CACHE_INFO[e][h[e]];
  else
    TotalBaseCache[e][h[e]] = malloc (TOTAL_CACHE_PER);
  CACHE_INFO[e][h[e]] = ci;
  if (tb->TYPE == DISCO_NON)
    {
      fseek (tb->Fdata, zo * TOTAL_CACHE_PER, SEEK_SET);
      fread (TotalBaseCache[e][h[e]], 1, TOTAL_CACHE_PER, tb->Fdata);
    }
  if (tb->BLOCCO_pro == 0x100000) /* 6 pezzo hiperindici */
    {
      ZO = zo & 0xf;
      zo >>= 4;
    }
  if (tb->TYPE == DISCO_COMPRESSO || tb->TYPE == DISCO_HUFFMAN)
    {
      uint32 ba = tb->indici[zo];
      sint32 lun = tb->indici[zo + 1] - ba; /* 32-bit plus under Windows ? */
      uint64 f = 0;
      uint64 pr = ba;
      char STR[1024];
      while (zo >= tb->supp_indice[f])
	f++;                           
      pr += (f << 32);
      if (!tb->Fdata)
	{
	  fc++;
	  if (fc == MASSIMO_FOPEN) /* close files when full */
	    {
	      for (i = 0; i < MAX_TABLES; i++)
		if ((TABLE_TOTAL_BASES + i)->Fdata)
		  {
		    fclose ((TABLE_TOTAL_BASES + i)->Fdata);
		    (TABLE_TOTAL_BASES + i)->Fdata = NULL;
		  }
	      fc = 1;
	    }
	  sprintf (STR, "%s%s%s", tb->DIR_NOME,
		   COMPRESSA_PREFISSO + 1, tb->string);
	  tb->Fdata = fopen (STR, "rb");
	}
      fseek (tb->Fdata, pr, 0);
      fread (BLOCCO, 1, lun, tb->Fdata);
      if (tb->BLOCCO_pro == 0x100000) /* 6 pezzo hiperindici */
	{
	  BPTR = BLOCCO + ((uint32*) (BLOCCO + (8 * ZO)))[0];
	  lun = ((uint32*) (BLOCCO + (8 * ZO + 4)))[0];
	}
      else BPTR = BLOCCO;
      blocco_decompressa (TotalBaseCache[e][h[e]], BPTR, lun, tb->TYPE);
    }
  return TotalBaseCache[e][h[e]];
}

int tot_valu (RobboTotalBase* tb, uint64 PositionCount) /* SMP the this */
{
  uint8 *A;
  A = scopPILA (tb, PositionCount);
  return A[PositionCount % TOTAL_CACHE_PER];
}

void re_fetta (RobboTotalBase* tb, int rf)
{
  uint8 *A;
  uint64 r, u = rf * tb->PawnMult, v = u + tb->PawnMult;
  for (r = u; r < v; r += TOTAL_CACHE_PER)
    A = scopPILA (tb, r);
}
