
#include "RobboLito.h"
#include "RobboTotalBase.h"

static void InitKingNormal ()
{
  int a, b, s = 0;
  for (a = A1; a <= H8; a++)
    for (b = A1; b <= H8; b++)
      {
	if (a == b || AttK[a] & SqSet[b])
	  {
	    RE_normale[64 * b + a] = -1;
	    continue;
	  }
	if (!(TRIANGOLO & SqSet[a]))
	  {
	    RE_normale[64 * b + a] = -1;
	    continue;
	  }
	if (MARGINE & SqSet[a] && !(TRI_MAR & SqSet[b]))
	  {
	    RE_normale[64 * b + a] = -1;
	    continue;
	  }
	RE_normale[64 * b + a] = s++;
      }
}

static void InitKingPedone ()
{
  int a, b, s = 0;
  for (a = A1; a <= H8; a++)
    for (b = A1; b <= H8; b++)
      {
	if (a == b || AttK[a] & SqSet[b])
	  {
	    RE_pedone[64 * b + a] = -1;
	    continue;
	  }
	if (FILE (a) >= FE)
	  {
	    RE_pedone[64 * b + a] = -1;
	    continue;
	  }
	RE_pedone[64 * b + a] = s++;
      }
}

static void InitInverse ()
{
  int wK, bK;
  for (wK = A1; wK <= H8; wK++)
    for (bK = A1; bK <= H8; bK++)
      {
	if (RE_normale[64 * wK + bK] != -1)
	  inverso_normale_re[RE_normale[64 * wK + bK]] = (wK << 6) | bK;
	if (RE_pedone[64 * wK + bK] != -1)
	  inverso_pedone_re[RE_pedone[64 * wK + bK]] = (wK << 6) | bK;
      }
}

static void InitDoubleSquare ()
{
  int a, b, s = 0;
  for (a = A1; a <= H8; a++)
    for (b = A1; b < a; b++)
      Sq2Normal[s++] = a | (b << 6);
  s = 0;
  for (a = A2; a <= H7; a++)
    for (b = A2; b < a; b++)
      Sq2Pawn[s++] = a | (b << 6);
  s = 0;
  for (a = A2; a <= H6; a++)
    for (b = A2; b < a; b++)
      Sq2Blocked[s++] = a | (b << 6);
}

static void iniz_triplo3 ()
{
  int a, b, c, s = 0;
  for (a = A1; a <= H8; a++)
    for (b = A1; b < a; b++)
      for (c = A1; c < b; c++)
	quad_tre_normale[s++] = a | (b << 6) | (c << 12);
  s = 0;
  for (a = A2; a <= H7; a++)
    for (b = A2; b < a; b++)
      for (c = A2; c < b; c++)
	quad_tre_pedone[s++] = a | (b << 6) | (c << 12);
  s = 0;
  for (a = A2; a <= H6; a++)
    for (b = A2; b < a; b++)
      for (c = A2; c < b; c++)
	quad_tre_blocked[s++] = a | (b << 6) | (c << 12);
}

static void iniz_quadruplo4 ()
{
  int a, b, c, d, s = 0;
  for (a = A1; a <= H8; a++)
    for (b = A1; b < a; b++)
      for (c = A1; c < b; c++)
	for (d = A1; d < c; d++)
	  quad_quat_normale[s++] = a | (b << 6) | (c << 12) | (d << 18);
  s = 0;
  for (a = A2; a <= H7; a++)
    for (b = A2; b < a; b++)
      for (c = A2; c < b; c++)
	for (d = A2; d < c; d++)
	  quad_quat_pedone[s++] = a | (b << 6) | (c << 12) | (d << 18);
  s = 0;
  for (a = A2; a <= H6; a++)
    for (b = A2; b < a; b++)
      for (c = A2; c < b; c++)
	for (d = A2; d < c; d++)
	  quad_quat_blocked[s++] = a | (b << 6) | (c << 12) | (d << 18);
}

static void iniz_lanc ()
{
  int wK, bK, K1, K2, u, sq;
  for (wK = A1; wK <= H8; wK++)
    for (bK = A1; bK <= H8; bK++)
      {
	K1 = bK;
	K2 = wK;
	u = 0;
	if (FILE (K1) >= FE)
	  {
	    u = 4;
	    LANCnor (4, K1);
	    LANCnor (4, K2);
	  }
	if (RANK (K1) >= R5)
	  {
	    u |= 2;
	    LANCnor (2, K1);
	    LANCnor (2, K2);
	  }
	if (RANK (K1) == FILE (K1) && RANK (K2) > FILE (K2))
	  u |= 1;
	else if (RANK (K1) > FILE (K1))
	  u |= 1;
	oLANC[wK][bK] = u;
      }
  for (sq = A1; sq <= H8; sq++)
    {
      lanc_pedone[0][sq] = sq;
      lanc_pedone[1][sq] = lanc_vert[sq];
      lanc_pedone[2][sq] = lanc_oriz[sq];
      lanc_pedone[3][sq] = (FH - FILE (sq)) + 8 * (R8 - RANK (sq));
    }
}

static void iniz_lanc_normale ()
{
  int i, sq, w;
  for (i = 0; i < 8; i++)
    for (sq = A1; sq <= H8; sq++)
      {
	w = sq;
	if (i & 4)
	  w = lanc_oriz[w];
	if (i & 2)
	  w = lanc_vert[w];
	if (i & 1)
	  w = lanc_diag[w];
	lanc_norm[i][sq] = w;
      }
}

static void InitDoubleSame ()
{
  int i, j;
  for (i = A1; i <= H8; i++)
    for (j = A1; j <= H8; j++)
      {
	STESSO2[i][j] =
	  (i > j) ? (i * (i + 1)) / 2 + j - i : (j * (j + 1)) / 2 + i - j;
      }
}

static void iniz_triplo ()
{
  int i, j, k, mas, mez, min;
  for (i = A1; i <= H8; i++)
    for (j = A1; j <= H8; j++)
      for (k = A1; k <= H8; k++)
	{
	  mas = MAX (MAX (i, j), k);
	  min = MIN (MIN (i, j), k);
	  if (i == mas)
	    mez = MAX (j, k);
	  if (j == mas)
	    mez = MAX (i, k);
	  if (k == mas)
	    mez = MAX (i, j);
	  STESSO3[i][j][k] = (mas * (mas - 1) * (mas - 2)) / 6 +
	                     (mez * (mez + 1)) / 2 - mez + min;
	}
}

static void iniz_quadruplo ()
{
  int i, j, k, l, mas, mez2, mez3, min;
  for (i = A1; i <= H8; i++)
    for (j = A1; j <= H8; j++)
      for (k = A1; k <= H8; k++)
	for (l = A1; l <= H8; l++)
	{
	  mas = MAX (MAX (i, j), MAX (k, l));
	  min = MIN (MIN (i, j), MIN (k, l));
	  if (i == mas)
	    mez2 = MAX (MAX (j, k), l);
	  if (j == mas)
	    mez2 = MAX (MAX (i, k), l);
	  if (k == mas)
	    mez2 = MAX (MAX (i, j), l);
	  if (l == mas)
	    mez2 = MAX (MAX (i, j), k);
	  if (i == min)
	    mez3 = MIN (MIN (j, k), l);
	  if (j == min)
	    mez3 = MIN (MIN (i, k), l);
	  if (k == min)
	    mez3 = MIN (MIN (i, j), l);
	  if (l == min)
	    mez3 = MIN (MIN (i, j), k);
	  STESSO4[i][j][k][l] =
	    (mas * (mas - 1) * (mas - 2) * (mas - 3)) / 24 +
	    (mez2 * (mez2 - 1) * (mez2 - 2)) / 6 +
	    (mez3 * (mez3 - 1)) / 2 + min;
	}
}

static void pila_lanc ()
{
  int pi, sq;
  for (pi = 0; pi < 16; pi++)
    col_scamb[pi] = pi ^ 8;
  col_scamb[0] = 0;
  col_scamb[8] = 8;
  for (sq = A1; sq <= H8; sq++)
    {
      lanc_oriz[sq] = (FH - FILE (sq)) + 8 * RANK (sq);
      lanc_vert[sq] = FILE (sq) + 8 * (R8 - RANK (sq));
      lanc_diag[sq] = 8 * FILE (sq) + RANK (sq);
    }
}

void InitTotalBaseUtility (boolean Build)
{
  pila_lanc ();
  strcpy (TOTAL_BASE_DIRECTORY, "RobboTotalBase");
  strcpy (COMPRESSA_PREFISSO, "iCOMP.");
  InitKingNormal ();
  InitKingPedone ();
  InitInverse ();
  InitDoubleSquare ();
  iniz_triplo3 ();
  if (Build) iniz_quadruplo4 ();
  iniz_lanc_normale ();
  iniz_lanc ();
  InitDoubleSame ();
  iniz_triplo ();
  if (Build) iniz_quadruplo ();
}

static int canonico_windows (char *AttB, boolean * simm)
{
  char Sort[16] = "KQRBNPZ";
  char A[32];
  int j, n, n2, i, SO[32];
  strcpy(A, AttB);
  A[16] = 0;
  for (i = 0; i < 16; i++)
    if (A[i] == '0')
      A[i] = 0;
  for (n = 0; n < 16; n++)
    if (!A[n]) break;
  for (i = n; i < 16; i++)
    A[i] = 0;
  for (i = 0; i < 16; i++)
    if (A[i] >= 'a')
      A[i] -= 32;
  for (i = 0; i < 16; i++)
    if (A[i] == 0)
      for (j = i; j < 4; j++)
	A[j] = 0;
  for (i = 0; i < 16; i++)
    if (!strchr (Sort, A[i]))
      A[i] = 0;
  for (n = 1; A[n] != 'K'; n++);
  for (i = 0; i < n; i++)
    for (j = 0; j < strlen (Sort); j++)
      if (Sort[j] == A[i])
	SO[i] = j;
  for (i = n - 1; i >= 1; i--)
    for (j = i + 1; j < n && SO[j - 1] > SO[j]; j++)
      {
	SCAMB (A[j - 1], A[j]);
	SCAMB (SO[j - 1], SO[j]);
      }
  for (n2 = n + 1; A[n2] ; n2++);
  for (i = n; i < n2; i++)
    for (j = 0; j < strlen (Sort); j++)
      if (Sort[j] == A[i])
	SO[i] = j;
  for (i = n + 1; i < n2; i++)
    for (j = 0; j < strlen (Sort); j++)
      if (Sort[j] == A[i])
	SO[i] = j;
  for (i = n2 - 1; i >= n + 1; i--)
    for (j = i + 1; j < n2 && SO[j - 1] > SO[j]; j++)
      {
	SCAMB (A[j - 1], A[j]);
	SCAMB (SO[j - 1], SO[j]);
      }

  if (n2 == 2)
    *simm = TRUE;
  if (n2 == 3 && SO[1] == 6)
    *simm = TRUE;
  if (n2 == 4 && (SO[1] == SO[3] || (SO[1] == 6 && SO[2] == 6)))
    *simm = TRUE;
  if (n2 == 5 && (SO[2] == 6 &&
		  (SO[1] == SO[4] || ( (SO[1] == 6 && SO[3] == 6)))))
    *simm = TRUE;
  if (n2 == 6 && (SO[2] == 6 && SO[3] == 6) &&
      ((SO[1] == 6 && SO[4] == 6) || (SO[1] == SO[5])))
    *simm = TRUE;
  if (n2 == 6 && SO[1] == SO[4] && SO[2] == SO[5])
    *simm = TRUE;
  return n;
}

int nome_canonico (char *A, boolean * simm)
{
  char Sort[16] = "QRBNPZqrbnp";
  int j, n, i, SO[MAX_NUM];
  if (A[0] == 'K' || A[0]=='k')
    return canonico_windows (A, simm);
  A[MAX_NUM] = 0;
  for (i = 0; i < MAX_NUM; i++)
    if (A[i] == '0')
      A[i] = 0;
  for (i = 0; i < MAX_NUM; i++)
    if (A[i] == 0)
      for (j = i; j < 4; j++)
	A[j] = 0;
  for (i = 0; i < MAX_NUM; i++)
    if (!strchr (Sort, A[i]))
      A[i] = 0;
  for (n = 0; A[n]; n++);
  for (i = 0; i < n; i++)
    for (j = 0; j < strlen (Sort); j++)
      if (Sort[j] == A[i])
	SO[i] = j;
  for (i = n - 1; i >= 0; i--)
    for (j = i + 1; j < n && SO[j - 1] > SO[j]; j++)
      {
	SCAMB (A[j - 1], A[j]);
	SCAMB (SO[j - 1], SO[j]);
      }
  if (n == 0)
    *simm = TRUE;
  if (n == 1 && SO[0] == 5)
    *simm = TRUE;
  if (n == 2 && (SO[0] + 6) == SO[1])
    *simm = TRUE;
  if (n == 2 && SO[0] == 5 && SO[1] == 5)
    *simm = TRUE;
  if (n == 3 && SO[1] == 5 &&
      ((SO[0] == 5 && SO[2] == 5) || (SO[0] + 6) == SO[2]))
    *simm = TRUE;
  if (n == 4 && SO[1] == 5 && SO[2] ==5 &&
      ((SO[0] == 5 && SO[3] == 5) || (SO[0] + 6) == SO[3]))
    *simm = TRUE;
  if (n == 4 && (SO[0] + 6) == SO[2] && (SO[1] + 6) == SO[3])
    *simm = TRUE;
  return n;
}

int RobboTotal_scop (char* NOME)
{
  int i, p[4] = { 0, 0, 0, 0 }, v;
  for (i = 0; i < 4 && NOME[i]; i++)
    {
      switch (NOME[i])
	{
	case 'Q':
	  p[i] = wEnumQ;
	  break;
	case 'q':
	  p[i] = bEnumQ;
	  break;
	case 'R':
	  p[i] = wEnumR;
	  break;
	case 'r':
	  p[i] = bEnumR;
	  break;
	case 'B':
	  p[i] = wEnumB;
	  break;
	case 'b':
	  p[i] = bEnumB;
	  break;
	case 'N':
	  p[i] = wEnumN;
	  break;
	case 'n':
	  p[i] = bEnumN;
	  break;
	case 'P':
	  p[i] = wEnumP;
	  break;
	case 'p':
	  p[i] = bEnumP;
	  break;
	case 'Z':
	  p[i] = BlockedPawn;
	  break;
	default:
	  p[i] = 0;
	}
    }
  v = TotalBaseTable[p[0]][p[1]][p[2]][p[3]];
  if (v != -1)
    v &= 65535;
  return v;
}

void RobboTotal_sott (char *NOME)
{
  int i, p[4] = { 0, 0, 0, 0 }, v;
  int i0, i1, i2, i3;
  for (i = 0; i < 4 && NOME[i]; i++)
    {
      switch (NOME[i])
	{
	case 'Q':
	  p[i] = wEnumQ;
	  break;
	case 'q':
	  p[i] = bEnumQ;
	  break;
	case 'R':
	  p[i] = wEnumR;
	  break;
	case 'r':
	  p[i] = bEnumR;
	  break;
	case 'B':
	  p[i] = wEnumB;
	  break;
	case 'b':
	  p[i] = bEnumB;
	  break;
	case 'N':
	  p[i] = wEnumN;
	  break;
	case 'n':
	  p[i] = bEnumN;
	  break;
	case 'P':
	  p[i] = wEnumP;
	  break;
	case 'p':
	  p[i] = bEnumP;
	  break;
	case 'Z':
	  p[i] = BlockedPawn;
	  break;
	default:
	  p[i] = 0;
	}
    }
  v = TotalBaseTable[p[0]][p[1]][p[2]][p[3]];
  if (v != -1)
    v &= 65535;
  if (v != -1 && (TABLE_TOTAL_BASES + v)->Fdata)
    fclose ((TABLE_TOTAL_BASES + v)->Fdata);
#define RTBx(a,b,c,d) TotalBaseTable[p[a]][p[b]][p[c]][p[d]]=-1;
  for (i0 = 0; i0 < 4; i0++)
    for (i1 = 0; i1 < 4; i1++)
      {
	if (i0 == i1)
	  continue;
	for (i2 = 0; i2 < 4; i2++)
	  {
	    if (i2 == i1 || i2 == i0)
	      continue;
	    for (i3 = 0; i3 < 4; i3++)
	      {
		if (i3 == i2 || i3 == i1 || i3 == i0)
		  continue;
		RTBx (i0, i1, i2, i3);
	      }
	  }
      }
}

#define VERBOSO TRUE

void un_windows (char* NOME)
{
  int c = 1, w = 0;
  while (NOME[c] != 'k' && NOME[c] != 'K')
    {
      NOME[w] = NOME[c++];
      if (NOME[w] > 96) NOME[w] -= 32;
      w++;
    }
  c++;
  while (NOME[c])
    {
      NOME[w] = NOME[c++];
      if (NOME[w] < 96) NOME[w] += 32;
      w++;
    }
  for ( ; w <= 4 ; w++)
    NOME[w] = 0;
}

void RobboTotal_add (RobboTotalBase* tb, char *NOME, char *DIRECTORY)
{
  int i, j, p[4];
  char NOME2[16];
  boolean PawnFlag = FALSE;
  int c = 1;
  if (NOME[0] == 'K' || NOME[0]=='k')
    un_windows (NOME);
  if (NOME[0] == '.')
    return;
  if (RobboTotal_scop (NOME) != -1)
    return;
  for (i = 0; i < 4; i++)
    if (NOME[i] == '0')
      NOME[i] = 0;
  for (i = 3; NOME[i - 2]; i++);
#ifdef NOME_WINDOWS
  NOME2[0] = 'K';
  j = 0;
  while (NOME[j] >= 'A' && NOME[j] <= 'Z')
    NOME2[c++] = NOME[j++];
  NOME2[c++] = 'K';
  while (NOME[j])
    NOME2[c++] = NOME[j++] - 32;
  NOME2[c]=0;
#else
  strcpy(NOME2, NOME);
#endif
  if (VERBOSO)
    SEND ("info string Register RobboTotalBase #%d %s\n", NUM_TOTAL_BASES, NOME2);
#if 0
  sprintf (tb->DIR_NOME, "%s/%d/", TOTAL_BASE_DIRECTORY, i);
#else
  sprintf (tb->DIR_NOME, "%s/", DIRECTORY);
#endif
  /* idee superiore: from the directory name by itself ? */
  /* plus why DIR_NOME while not FILE_NAME ? */
  /* Fact: DIR_NOME achieves from the <<build>> with the Comrade Roberto */
  strcpy (tb->string, NOME2);
  for (i = 0; i < 4; i++)
    {
      switch (NOME[i])
	{
	case 'Q':
	  p[i] = wEnumQ;
	  break;
	case 'q':
	  p[i] = bEnumQ;
	  break;
	case 'R':
	  p[i] = wEnumR;
	  break;
	case 'r':
	  p[i] = bEnumR;
	  break;
	case 'B':
	  p[i] = wEnumB;
	  break;
	case 'b':
	  p[i] = bEnumB;
	  break;
	case 'N':
	  p[i] = wEnumN;
	  break;
	case 'n':
	  p[i] = bEnumN;
	  break;
	case 'P':
	  p[i] = wEnumP;
	  break;
	case 'p':
	  p[i] = bEnumP;
	  break;
	case 'Z':
	  p[i] = BlockedPawn;
	  break;
	default:
	  p[i] = 0;
	}
      if (p[i])
	{
	  if (p[i] == wEnumP || p[i] == bEnumP)
	    tb->m[i] = 48;
	  else if (p[i] == BlockedPawn)
	    tb->m[i] = 40;
	  else
	    tb->m[i] = 64;
	}
      else
	tb->m[i] = 1;
    }
  if (p[0] && p[0] == p[3])
    {
      tb->m[0] =(tb->m[0] * (tb->m[0] - 1) *
		 (tb->m[0] - 2) * (tb->m[0] - 3)) / 24;
      tb->m[1] = tb->m[2] = tb->m[3] = 1;
    }
  else if (p[0] && p[0] == p[2])
    {
      tb->m[0] = (tb->m[0] * (tb->m[0] - 1) * (tb->m[0] - 2)) / 6;
      tb->m[1] = tb->m[2] = 1;
    }
  else if (p[1] && p[1] == p[3])
    {
      tb->m[1] = (tb->m[1] * (tb->m[1] - 1) * (tb->m[1] - 2)) / 6;
      tb->m[2] = tb->m[3] = 1;
    }
  else
    {
      if (p[0] && p[0] == p[1])
	{
	  tb->m[0] = (tb->m[0] * (tb->m[0] - 1)) / 2;
	  tb->m[1] = 1;
	}
      if (p[1] && p[1] == p[2])
	{
	  tb->m[1] = (tb->m[1] * (tb->m[1] - 1)) / 2;
	  tb->m[2] = 1;
	}
      if (p[2] && p[2] == p[3])
	{
	  tb->m[2] = (tb->m[2] * (tb->m[2] - 1)) / 2;
	  tb->m[3] = 1;
	}
    }
  for (i = 0; i < 4; i++)
    {
      tb->p[i] = p[i];
      if (p[i] == wEnumP || p[i] == bEnumP || p[i] == BlockedPawn)
	PawnFlag = TRUE;
    }
  tb->PEDONE = PawnFlag;
  tb->pro = 1;
  for (i = 0; i < 4; i++)
    tb->pro *= tb->m[i];
  tb->num = NUM_TOTAL_BASES;
  tb->PawnMult = tb->pro;
  if (!PawnFlag)
    tb->pro *= 462;
  else
    tb->pro *= 1806;
  TotalBaseTable[p[0]][p[1]][p[2]][p[3]] =
    NUM_TOTAL_BASES + (0 << 16) + (1 << 18) + (2 << 20) + (3 << 22);
  TotalBaseTable[p[1]][p[0]][p[2]][p[3]] =
    NUM_TOTAL_BASES + (1 << 16) + (0 << 18) + (2 << 20) + (3 << 22);
  TotalBaseTable[p[0]][p[2]][p[1]][p[3]] =
    NUM_TOTAL_BASES + (0 << 16) + (2 << 18) + (1 << 20) + (3 << 22);
  TotalBaseTable[p[1]][p[2]][p[0]][p[3]] =
    NUM_TOTAL_BASES + (2 << 16) + (0 << 18) + (1 << 20) + (3 << 22);
  TotalBaseTable[p[2]][p[0]][p[1]][p[3]] =
    NUM_TOTAL_BASES + (1 << 16) + (2 << 18) + (0 << 20) + (3 << 22);
  TotalBaseTable[p[2]][p[1]][p[0]][p[3]] =
    NUM_TOTAL_BASES + (2 << 16) + (1 << 18) + (0 << 20) + (3 << 22);

  TotalBaseTable[p[0]][p[1]][p[3]][p[2]] =
    NUM_TOTAL_BASES + (0 << 16) + (1 << 18) + (3 << 20) + (2 << 22);
  TotalBaseTable[p[0]][p[2]][p[3]][p[1]] =
    NUM_TOTAL_BASES + (0 << 16) + (3 << 18) + (1 << 20) + (2 << 22);
  TotalBaseTable[p[1]][p[0]][p[3]][p[2]] =
    NUM_TOTAL_BASES + (1 << 16) + (0 << 18) + (3 << 20) + (2 << 22);
  TotalBaseTable[p[1]][p[2]][p[3]][p[0]] =
    NUM_TOTAL_BASES + (3 << 16) + (0 << 18) + (1 << 20) + (2 << 22);
  TotalBaseTable[p[2]][p[0]][p[3]][p[1]] =
    NUM_TOTAL_BASES + (1 << 16) + (3 << 18) + (0 << 20) + (2 << 22);
  TotalBaseTable[p[2]][p[1]][p[3]][p[0]] =
    NUM_TOTAL_BASES + (3 << 16) + (1 << 18) + (0 << 20) + (2 << 22);

  TotalBaseTable[p[0]][p[3]][p[1]][p[2]] =
    NUM_TOTAL_BASES + (0 << 16) + (2 << 18) + (3 << 20) + (1 << 22);
  TotalBaseTable[p[0]][p[3]][p[2]][p[1]] =
    NUM_TOTAL_BASES + (0 << 16) + (3 << 18) + (2 << 20) + (1 << 22);
  TotalBaseTable[p[1]][p[3]][p[0]][p[2]] =
    NUM_TOTAL_BASES + (2 << 16) + (0 << 18) + (3 << 20) + (1 << 22);
  TotalBaseTable[p[1]][p[3]][p[2]][p[0]] =
    NUM_TOTAL_BASES + (3 << 16) + (0 << 18) + (2 << 20) + (1 << 22);
  TotalBaseTable[p[2]][p[3]][p[0]][p[1]] =
    NUM_TOTAL_BASES + (2 << 16) + (3 << 18) + (0 << 20) + (1 << 22);
  TotalBaseTable[p[2]][p[3]][p[1]][p[0]] =
    NUM_TOTAL_BASES + (3 << 16) + (2 << 18) + (0 << 20) + (1 << 22);

  TotalBaseTable[p[3]][p[0]][p[1]][p[2]] =
    NUM_TOTAL_BASES + (1 << 16) + (2 << 18) + (3 << 20) + (0 << 22);
  TotalBaseTable[p[3]][p[0]][p[2]][p[1]] =
    NUM_TOTAL_BASES + (1 << 16) + (3 << 18) + (2 << 20) + (0 << 22);
  TotalBaseTable[p[3]][p[1]][p[0]][p[2]] =
    NUM_TOTAL_BASES + (2 << 16) + (1 << 18) + (3 << 20) + (0 << 22);
  TotalBaseTable[p[3]][p[1]][p[2]][p[0]] =
    NUM_TOTAL_BASES + (3 << 16) + (1 << 18) + (2 << 20) + (0 << 22);
  TotalBaseTable[p[3]][p[2]][p[0]][p[1]] =
    NUM_TOTAL_BASES + (2 << 16) + (3 << 18) + (1 << 20) + (0 << 22);
  TotalBaseTable[p[3]][p[2]][p[1]][p[0]] =
    NUM_TOTAL_BASES + (3 << 16) + (2 << 18) + (1 << 20) + (0 << 22);
  NUM_TOTAL_BASES++;
}


int STAT (char *filename); /* non funzione Windows */
boolean RobboTotal_registro (char* nome, char *DIRECTORY)
{
  int i, j;
  RobboTotalBase* tb;
  char NOME[64], NOME_FILE[1024];
  FILE* F;
  uint8 A[4];
  uint32 n = 0;
  int num_indici = 0;
  int e = 0;
  strcpy (NOME, nome);
  if (NOME[0] == 'K' || NOME[0] == 'k')
    un_windows (NOME);
  for (i = 0; i < 4; i++)
    if (NOME[i] == '0')
      NOME[i] = 0;
  for (i = 0; i < 4; i++)
    if (NOME[i] == 0)
      for (j = i; j < 4; j++)
	NOME[j] = 0;
  NOME[4] = 0;
  for (i = 3; NOME[i - 2]; i++);

  if (RobboTotal_scop (NOME) != -1)
    return FALSE;
  tb = TABLE_TOTAL_BASES + NUM_TOTAL_BASES;
  tb->TYPE = DISCO_COMPRESSO;
  RobboTotal_add (tb, NOME, DIRECTORY);
  sprintf (NOME_FILE, "%s%s%s", tb->DIR_NOME, COMPRESSA_PREFISSO, tb->string);
  F = fopen (NOME_FILE, "rb");
  if (!F)
    printf ("FOPEN failed %s\n", NOME_FILE);
  if (!F)
    return FALSE;
  fread (A, 1, 4, F);
  /* Header 0xca 0x7f 0x0b 0xaa */
  if (A[0] != 0xca || A[1] != 0x7f || A[2] != 0x0b || A[3] != 0xaa)
    {
      printf ("DATA failed %s\n", NOME_FILE);
      fclose (F);
      return FALSE;
    }
  /* Header, block size and compression type */
  fread (A, 1, 4, F);
  for (i = 0; i < 4; i++)
    n |= A[i] << (8 * i);
  tb->BLOCCO_pro = n & ((1 << 28) - 1);
  tb->BWT = n >> 28;
  fread (A, 1, 4, F);
  /* Header, null 4 bytes */
  fread (A, 1, 4, F);
  /* Header, number of indices */
  for (i = 0; i < 4; i++)
    num_indici |= A[i] << (8 * i);
  tb->indici = malloc (4 * num_indici);
  fread (tb->indici, 4, num_indici, F); /* ENDIAN */
  TOT_INDICI += num_indici;
  fclose (F);

  /* above 32-bit with index */
  for (i = 0; i < 8; i++)
    tb->supp_indice[i] = 0xffffffff;
  for (i = 1; i <= num_indici - 1; i++)
    if (tb->indici[i] < tb->indici[i - 1])
      tb->supp_indice[e++] = i;
  sprintf (NOME_FILE, "%s%s%s", tb->DIR_NOME, COMPRESSA_PREFISSO + 1,
	   tb->string);
  tb->Fdata = NULL;
  if (STAT (NOME_FILE) == -1)
    {
      printf ("STAT failed %s\n", NOME_FILE);
      free (tb->indici);
      return FALSE;
    }
  return TRUE;
}
